ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.8 by root, Tue Dec 7 19:55:56 2010 UTC vs.
Revision 1.49 by root, Sun Jul 10 01:37:56 2011 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in (or to replace in your .staticperlrc)
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9DLCACHE=
10MKBUNDLE="$STATICPERL/mkbundle"
11 10
12# perl build variables 11# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 12MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 13PERL_VERSION=5.12.4 # 5.8.9 is also a good choice
14PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 15PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 16PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 18
19ARCH="$(uname -m)" 19ARCH="$(uname -m)"
20 20
21case "$ARCH" in 21case "$ARCH" in
29 ;; 29 ;;
30esac 30esac
31 31
32# -Wl,--gc-sections makes it impossible to check for undefined references 32# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 33# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 34# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 35#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LDFLAGS=
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 37PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 38
38# some configuration options for modules 39# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 40PERL_MM_USE_DEFAULT=1
41PERL_MM_OPT="MAN1PODS= MAN3PODS="
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 42#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 43#EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
44export PERL_MM_USE_DEFAULT PERL_MM_OPT
42 45
43# which extra modules to install by default from CPAN that are 46# which extra modules to install by default from CPAN that are
44# required by mkbundle 47# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 48STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 49
47# which extra modules you might want to install 50# which extra modules you might want to install
48EXTRA_MODULES="" 51EXTRA_MODULES=""
49 52
50# overridable functions 53# overridable functions
51preconfigure() { : ; } 54preconfigure() { : ; }
55patchconfig() { : ; }
52postconfigure() { : ; } 56postconfigure() { : ; }
53postbuild() { : ; } 57postbuild() { : ; }
54postinstall() { : ; } 58postinstall() { : ; }
55 59
56# now source user config, if any 60# now source user config, if any
61if [ "$STATICPERLRC" ]; then
62 . "$STATICPERLRC"
63else
57[ -r /etc/staticperlrc ] && . /etc/staticperlrc 64 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
58[ -r ~/.staticperlrc ] && . ~/.staticperlrc 65 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
59[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 66 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
67fi
60 68
61############################################################################# 69#############################################################################
62# support 70# support
71
72PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
73
74unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
75unset PERL_MB_OPT
76LC_ALL=C; export LC_ALL # just to be on the safe side
77
78# prepend PATH - not required by staticperl itself, but might make
79# life easier when working in e.g. "staticperl cpan / look"
80PATH="$PERL_PREFIX/perl/bin:$PATH"
63 81
64# set version in a way that Makefile.PL can extract 82# set version in a way that Makefile.PL can extract
65VERSION=VERSION; eval \ 83VERSION=VERSION; eval \
66$VERSION=0.1 84$VERSION="1.31"
67 85
68BZ2=bz2 86BZ2=bz2
69BZIP2=bzip2 87BZIP2=bzip2
70 88
71fatal() { 89fatal() {
104############################################################################# 122#############################################################################
105# clean 123# clean
106 124
107distclean() { 125distclean() {
108 verblock <<EOF 126 verblock <<EOF
109deleting everything installed by this script 127 deleting everything installed by this script (rm -rf $STATICPERL)
110EOF 128EOF
111 129
112 rm -rf "$STATICPERL" 130 rm -rf "$STATICPERL"
113} 131}
114 132
115############################################################################# 133#############################################################################
116# download/configure/compile/install perl 134# download/configure/compile/install perl
117 135
118clean() { 136clean() {
119 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 137 rm -rf "$STATICPERL/src"
138}
139
140realclean() {
141 rm -f "$PERL_PREFIX/staticstamp.postinstall"
142 rm -f "$PERL_PREFIX/staticstamp.install"
143 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
120} 144}
121 145
122fetch() { 146fetch() {
123 rcd "$STATICPERL" 147 rcd "$STATICPERL"
124 148
125 mkdir -p src 149 mkdir -p src
126 rcd src 150 rcd src
127 151
128 if ! [ -d "perl-$PERL_VERSION" ]; then 152 if ! [ -d "perl-$PERL_VERSION" ]; then
129 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then 153 PERLTAR=perl-$PERL_VERSION.tar.$BZ2
130 154
155 if ! [ -e $PERLTAR ]; then
131 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2" 156 URL="$CPAN/src/5.0/$PERLTAR"
132 157
133 verblock <<EOF 158 verblock <<EOF
134downloading perl 159downloading perl
135to manually download perl yourself, place 160to manually download perl yourself, place
136perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 161perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
137trying $URL 162trying $URL
138EOF
139 163
164either curl or wget is required for automatic download.
165curl is tried first, then wget.
166
167you can configure a download cache directory via DLCACHE
168in your .staticperlrc to avoid repeated downloads.
169EOF
170
140 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 171 rm -f $PERLTAR~ # just to be on the safe side
141 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 172 { [ "$DLCACHE" ] && cp "$DLCACHE"/$PERLTAR $PERLTAR~ >/dev/null 2>&1; } \
142 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 173 || wget -O $PERLTAR~ "$URL" \
174 || curl -f >$PERLTAR~ "$URL" \
143 || fatal "$URL: unable to download" 175 || fatal "$URL: unable to download"
144 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 176 rm -f $PERLTAR
177 mv $PERLTAR~ $PERLTAR
178 if [ "$DLCACHE" ]; then
179 mkdir -p "$DLCACHE"
180 cp $PERLTAR "$DLCACHE"/$PERLTAR~ && \
181 mv "$DLCACHE"/$PERLTAR~ "$DLCACHE"/$PERLTAR
182 fi
145 fi 183 fi
146 184
147 verblock <<EOF 185 verblock <<EOF
148unpacking perl 186unpacking perl
149EOF 187EOF
150 188
151 mkdir -p unpack 189 mkdir -p unpack
152 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xC unpack \ 190 rm -rf unpack/perl-$PERL_VERSION
191 $BZIP2 -d <$PERLTAR | ( cd unpack && tar xf - ) \
153 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 192 || fatal "$PERLTAR: error during unpacking"
154 chmod -R u+w unpack/perl-$PERL_VERSION 193 chmod -R u+w unpack/perl-$PERL_VERSION
155 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 194 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
156 rmdir -p unpack 195 rmdir -p unpack
157 fi 196 fi
158} 197}
159 198
160# similar to GNU-sed -i or perl -pi 199# similar to GNU-sed -i or perl -pi
161sedreplace() { 200sedreplace() {
162 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 201 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
202 rm -f "$2"
163 mv "$2~" "$2" 203 mv "$2~" "$2"
204}
205
206configure_failure() {
207 cat <<EOF
208
209
210***
211*** Configure failed - see above for the exact error message(s).
212***
213*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
214*** flags are not supported by your compiler. Less often, this is because
215*** PERL_LIBS either contains a library not available on your system (such as
216*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
217***
218*** You can provide your own flags by creating a ~/.staticperlrc file with
219*** variable assignments. For example (these are the actual values used):
220***
221
222PERL_CC="$PERL_CC"
223PERL_CCFLAGS="$PERL_CCFLAGS"
224PERL_OPTIMIZE="$PERL_OPTIMIZE"
225PERL_LDFLAGS="$PERL_LDFLAGS"
226PERL_LIBS="$PERL_LIBS"
227
228EOF
229 exit 1
164} 230}
165 231
166configure() { 232configure() {
167 fetch 233 fetch
168 234
174configuring $STATICPERL/src/perl-$PERL_VERSION 240configuring $STATICPERL/src/perl-$PERL_VERSION
175EOF 241EOF
176 242
177 rm -f "$PERL_PREFIX/staticstamp.install" 243 rm -f "$PERL_PREFIX/staticstamp.install"
178 244
179 make distclean >/dev/null 2>&1 245 "$MAKE" distclean >/dev/null 2>&1
180 246
247 sedreplace '/^#define SITELIB/d' config_h.SH
248
181 # I hate them 249 # I hate them for this
182 grep -q -- -fstack-protector Configure && \ 250 grep -q -- -fstack-protector Configure && \
183 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 251 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
184 252
185 preconfigure 253 # what did that bloke think
254 grep -q -- usedl=.define hints/darwin.sh && \
255 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
256
257 preconfigure || fatal "preconfigure hook failed"
186 258
187# trace configure \ 259# trace configure \
188 sh Configure -Duselargefiles \ 260 sh Configure -Duselargefiles \
189 -Uuse64bitint \ 261 -Uuse64bitint \
190 -Dusemymalloc=n \ 262 -Dusemymalloc=n \
191 -Uusedl \ 263 -Uusedl \
192 -Uusethreads \ 264 -Uusethreads \
193 -Uuseithreads \ 265 -Uuseithreads \
194 -Uusemultiplicity \ 266 -Uusemultiplicity \
195 -Duseperlio \
196 -Uusesfio \ 267 -Uusesfio \
197 -Uuseshrplib \ 268 -Uuseshrplib \
269 -Uinstallusrbinperl \
198 -Dcppflags="$PERL_CPPFLAGS" \ 270 -A ccflags=" $PERL_CCFLAGS" \
199 -Dccflags="-g2 -fno-strict-aliasing" \ 271 -Dcc="$PERL_CC" \
200 -Doptimize="$PERL_OPTIMIZE" \ 272 -Doptimize="$PERL_OPTIMIZE" \
201 -Dldflags="$PERL_LDFLAGS" \ 273 -Dldflags="$PERL_LDFLAGS" \
202 -Dlibs="$PERL_LIBS" \ 274 -Dlibs="$PERL_LIBS" \
203 -Dprefix="$PERL_PREFIX" \ 275 -Dprefix="$PERL_PREFIX" \
204 -Dbin="$PERL_PREFIX/bin" \ 276 -Dbin="$PERL_PREFIX/bin" \
205 -Dprivlib="$PERL_PREFIX/lib" \ 277 -Dprivlib="$PERL_PREFIX/lib" \
206 -Darchlib="$PERL_PREFIX/lib" \ 278 -Darchlib="$PERL_PREFIX/lib" \
207 -Uusevendorprefix \ 279 -Uusevendorprefix \
208 -Dsitelib="$PERL_PREFIX/lib" \ 280 -Dsitelib="$PERL_PREFIX/lib" \
209 -Dsitearch="$PERL_PREFIX/lib" \ 281 -Dsitearch="$PERL_PREFIX/lib" \
210 -Usitelibexp \
211 -Uman1dir \ 282 -Uman1dir \
212 -Uman3dir \ 283 -Uman3dir \
213 -Usiteman1dir \ 284 -Usiteman1dir \
214 -Usiteman3dir \ 285 -Usiteman3dir \
215 -Dpager=/usr/bin/less \ 286 -Dpager=/usr/bin/less \
216 -Demail="$EMAIL" \ 287 -Demail="$EMAIL" \
217 -Dcf_email="$EMAIL" \ 288 -Dcf_email="$EMAIL" \
218 -Dcf_by="$EMAIL" \ 289 -Dcf_by="$EMAIL" \
219 $PERL_CONFIGURE \ 290 $PERL_CONFIGURE \
291 -Duseperlio \
220 -dE || fatal "Configure failed" 292 -dE || configure_failure
221 293
222 sedreplace ' 294 sedreplace '
223 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 295 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
224 s/ *-fno-stack-protector */ /g 296 s/ *-fno-stack-protector */ /g
225 ' config.sh 297 ' config.sh
226 298
299 patchconfig || fatal "patchconfig hook failed"
300
227 sh Configure -S || fatal "Configure -S failed" 301 sh Configure -S || fatal "Configure -S failed"
228 302
229 postconfigure || fatal "postconfigure hook failed" 303 postconfigure || fatal "postconfigure hook failed"
230 304
231 touch staticstamp.configure 305 : > staticstamp.configure
306}
307
308write_shellscript() {
309 {
310 echo "#!/bin/sh"
311 echo "STATICPERL=\"$STATICPERL\""
312 echo "PERL_PREFIX=\"$PERL_PREFIX\""
313 echo "MAKE=\"$MAKE\""
314 cat
315 } >"$PERL_PREFIX/bin/$1"
316 chmod 755 "$PERL_PREFIX/bin/$1"
232} 317}
233 318
234build() { 319build() {
235 configure 320 configure
236 321
240building $STATICPERL/src/perl-$PERL_VERSION 325building $STATICPERL/src/perl-$PERL_VERSION
241EOF 326EOF
242 327
243 rm -f "$PERL_PREFIX/staticstamp.install" 328 rm -f "$PERL_PREFIX/staticstamp.install"
244 329
245 make || fatal "make: error while building perl" 330 "$MAKE" || fatal "make: error while building perl"
246 331
247 postbuild || fatal "postbuild hook failed" 332 postbuild || fatal "postbuild hook failed"
248} 333}
249 334
335_postinstall() {
336 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
337 NOCHECK_INSTALL=+
338 instcpan $STATICPERL_MODULES
339 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
340
341 postinstall || fatal "postinstall hook failed"
342
343 : > "$PERL_PREFIX/staticstamp.postinstall"
344 fi
345}
346
250install() { 347install() {
251 [ -e "$PERL_PREFIX/staticstamp.install" ] && return 348 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
252
253 build 349 build
254 350
255 verblock <<EOF 351 verblock <<EOF
256installing $STATICPERL/src/perl-$PERL_VERSION 352installing $STATICPERL/src/perl-$PERL_VERSION
257to $PERL_PREFIX 353to $PERL_PREFIX
258EOF 354EOF
259 355
260 rm -rf "$PERL_PREFIX" 356 ln -sf "perl/bin/" "$STATICPERL/bin"
261 357 ln -sf "perl/lib/" "$STATICPERL/lib"
358
359 mkdir "$STATICPERL/patched"
360
361 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
362 rm -rf "$PERL_PREFIX" # by this rm -rf
363
262 make install || fatal "make install: error while installing" 364 "$MAKE" install || fatal "make install: error while installing"
263 365
264 rcd "$PERL_PREFIX" 366 rcd "$PERL_PREFIX"
265 367
266 # create a "make install" replacement for CPAN 368 # create a "make install" replacement for CPAN
267 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 369 write_shellscript SP-make-install-make <<'EOF'
268make install UNINST=1 370#CAT make-install-make.sh
269if find blib/arch/auto -type f | grep -q -v .exists; then
270 echo Probably an XS module, rebuilding perl
271 make perl
272 rm -f "$PERL_PREFIX"/bin/perl
273 make -f Makefile.aperl inst_perl
274 make -f Makefile.aperl map_clean
275fi
276EOF 371EOF
277 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
278 372
373 # create a "patch modules" helper
374 write_shellscript SP-patch-postinstall <<'EOF'
375#CAT patch-postinstall.sh
376EOF
377
378 "$PERL_PREFIX/bin/SP-patch-postinstall"
379
279 # trick CPAN into avoiding ~/.cpan completely 380 # help to trick CPAN into avoiding ~/.cpan completely
280 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 381 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
281 382
383 # we call cpan with -MCPAN::MyConfig in this script, which
384 # is strictly unnecssary as we have to patch CPAN anyway,
385 # so consider it "for good measure".
282 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 386 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
283 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 387 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
284 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 388 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
285 CPAN::Shell->o (conf => q<init>); 389 CPAN::Shell->o (conf => q<init>);
286 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 390 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
287 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 391 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
288 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 392 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
289 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 393 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
290 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 394 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
291 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 395 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
292 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 396 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
293 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 397 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
398 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
294 CPAN::Shell->o (conf => q<commit>); 399 CPAN::Shell->o (conf => q<commit>);
295 ' || fatal "error while initialising CPAN" 400 ' || fatal "error while initialising CPAN"
296 401
297 NOCHECK_INSTALL=+
298 instcpan $STATICPERL_MODULES
299 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
300
301 postinstall || fatal "postinstall hook failed"
302
303 touch "$PERL_PREFIX/staticstamp.install" 402 : > "$PERL_PREFIX/staticstamp.install"
403 fi
404
405 _postinstall
406}
407
408import() {
409 IMPORT="$1"
410
411 rcd "$STATICPERL"
412
413 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
414 verblock <<EOF
415import perl from $IMPORT to $STATICPERL
416EOF
417
418 rm -rf bin cpan lib patched perl src
419 mkdir -m 755 perl perl/bin
420 ln -s perl/bin/ bin
421 ln -s "$IMPORT" perl/bin/
422
423 : > "$PERL_PREFIX/staticstamp.install"
424 fi
425
426 _postinstall
304} 427}
305 428
306############################################################################# 429#############################################################################
307# install a module from CPAN 430# install a module from CPAN
308 431
312 verblock <<EOF 435 verblock <<EOF
313installing modules from CPAN 436installing modules from CPAN
314$@ 437$@
315EOF 438EOF
316 439
317 for mod in "$@"; do 440 #"$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install $_ for @ARGV' -- "$@" | tee "$STATICPERL/instcpan.log"
318 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 441 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install $_ for @ARGV' -- "$@" | tee "$STATICPERL/instcpan.log"
319 || fatal "$mod: unable to install from CPAN" 442
320 done 443 if grep -q " -- NOT OK\$" "$STATICPERL/instcpan.log"; then
444 fatal "failure while installing modules from CPAN ($@)"
445 fi
321 rm -rf "$STATICPERL/build" 446 rm -f "$STATICPERL/instcpan.log"
322} 447}
323 448
324############################################################################# 449#############################################################################
325# install a module from unpacked sources 450# install a module from unpacked sources
326 451
335 for mod in "$@"; do 460 for mod in "$@"; do
336 echo 461 echo
337 echo $mod 462 echo $mod
338 ( 463 (
339 rcd $mod 464 rcd $mod
340 make -f Makefile.aperl map_clean >/dev/null 2>&1 465 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
341 make distclean >/dev/null 2>&1 466 "$MAKE" distclean >/dev/null 2>&1
342 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 467 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
343 make || fatal "$mod: error building module" 468 "$MAKE" || fatal "$mod: error building module"
344 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 469 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
345 make distclean >/dev/null 2>&1 470 "$MAKE" distclean >/dev/null 2>&1
346 exit 0 471 exit 0
347 ) || exit $? 472 ) || exit $?
348 done 473 done
349} 474}
350 475
351############################################################################# 476#############################################################################
352# main 477# main
353 478
354podusage() { 479podusage() {
355 echo 480 echo
481
356 if [ -e "$PERL_PREFIX/bin/perl" ]; then 482 if [ -e "$PERL_PREFIX/bin/perl" ]; then
357 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 483 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
358 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 484 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
359 2>/dev/null && exit 485 2>/dev/null && exit
360 fi 486 fi
487
361 # try whatever perl we can find 488 # try whatever perl we can find
362 perl -MPod::Usage -e \ 489 perl -MPod::Usage -e \
363 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 490 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
364 2>/dev/null && exit 491 2>/dev/null && exit
365 492
366 fatal "displaying documentation requires a working perl - try '$0 install' first" 493 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
367} 494}
368 495
369usage() { 496usage() {
370 podusage 0 497 podusage 0
371} 498}
379#CAT mkbundle 506#CAT mkbundle
380MKBUNDLE 507MKBUNDLE
381} 508}
382 509
383bundle() { 510bundle() {
511 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
384 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 512 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
385 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 513 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
514 CACHE="$STATICPERL/cache"
515 mkdir -p "$CACHE"
386 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 516 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
387} 517}
388 518
389if [ $# -gt 0 ]; then 519if [ $# -gt 0 ]; then
390 while [ $# -gt 0 ]; do 520 while [ $# -gt 0 ]; do
391 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 521 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
392 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 522 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
393 523
394 command="${1#--}"; shift 524 command="${1#--}"; shift
395 case "$command" in 525 case "$command" in
526 version )
527 echo "staticperl version $VERSION"
528 ;;
396 fetch | configure | build | install | clean | distclean) 529 fetch | configure | build | install | clean | realclean | distclean )
397 verblock <<EOF
398$command
399EOF
400 ( "$command" ) 530 ( "$command" ) || exit
531 ;;
532 import )
533 ( import "$1" ) || exit
534 shift
401 ;; 535 ;;
402 instsrc ) 536 instsrc )
403 ( instsrc "$@" ) 537 ( instsrc "$@" ) || exit
404 exit 538 exit
405 ;; 539 ;;
406 instcpan ) 540 instcpan )
407 ( instcpan "$@" ) 541 ( instcpan "$@" ) || exit
542 exit
543 ;;
544 perl )
545 ( install ) || exit
546 exec "$PERL_PREFIX/bin/perl" "$@"
408 exit 547 exit
409 ;; 548 ;;
410 cpan ) 549 cpan )
411 ( install ) 550 ( install ) || exit
551 PERL="$PERL_PREFIX/bin/perl"
552 export PERL
412 "$PERL_PREFIX/bin/cpan" "$@" 553 exec "$PERL_PREFIX/bin/cpan" "$@"
413 exit 554 exit
414 ;; 555 ;;
415 mkbundle ) 556 mkbundle )
416 ( install ) 557 ( install ) || exit
417 bundle "$@" 558 bundle "$@"
418 exit 559 exit
419 ;; 560 ;;
420 mkperl ) 561 mkperl )
421 ( install ) 562 ( install ) || exit
422 bundle --perl "$@" 563 bundle --perl "$@"
564 exit
565 ;;
566 mkapp )
567 ( install ) || exit
568 bundle --app "$@"
423 exit 569 exit
424 ;; 570 ;;
425 help ) 571 help )
426 podusage 2 572 podusage 2
427 ;; 573 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines